package rwd.concretesyntax.constraintdiagram;

import java.util.Vector;

/**
 * @author Octavian Patrascoiu
 *
 */
public class ConcreteArcSet 
	implements java.io.Serializable 
{
	public ConcreteArcSet() {
	}

	public ConcreteArcSet(Vector arcs) {
		this.arcs = arcs;
	}
    
	public Vector getArcs() {
		return arcs;
	}
	public void addArc(ConcreteArc arc) {
		arcs.add(arc);
	}
	public void removeArc(ConcreteArc arc) {
		arcs.remove(arc);
	}
	
	public ConcreteArcSet getClone() {
		Vector newArcs = new Vector();
		for(int i=0; i<arcs.size(); i++) {
			ConcreteArc newArc = (ConcreteArc)((ConcreteArc)arcs.get(i)).getClone();
			newArcs.add(newArc);
		}
		return new ConcreteArcSet(newArcs);
	}

	private Vector arcs = new Vector();
}
