package rwd.concretesyntax.constraintdiagram;

import java.util.Vector;

/**
 * @author Octavian Patrascoiu
 *
 */
public class ConcreteTextBoxSet 
	implements java.io.Serializable 
{
	public ConcreteTextBoxSet() {
	}

	public ConcreteTextBoxSet(Vector boxes) {
		this.boxes = boxes;
	}
    
	public Vector getTexts() {
		return boxes;
	}
	public void addTextBox(ConcreteTextBox text) {
		boxes.add(text);
	}
	public void removeTextBox(ConcreteTextBox text) {
		boxes.remove(text);
	}

	public ConcreteTextBoxSet getClone() {
		Vector newBoxes = new Vector();
		for(int i=0; i<boxes.size(); i++) {
			ConcreteTextBox oldBox = (ConcreteTextBox)boxes.get(i);
			ConcreteTextBox newBox = (ConcreteTextBox)oldBox.getClone();
			newBoxes.add(newBox);
		}
		return new ConcreteTextBoxSet(newBoxes);
	}
    
	// Local properties
	private Vector boxes = new Vector();

}
