package rwd.gui;
import java.util.Vector;
import rwd.rules.Proof;
import javax.swing.SwingUtilities;

public class ProofManager {
	static Vector proofs = new Vector();
	static Vector viewers = new Vector();

	public static void showNewProof(final Proof p, final boolean autoUpdate, final boolean tryToDrawPictures) {
		//p.goToStart();
		//int stepNumber = 0;
		//while (p.goToNextStep()) {
			//System.out.println("next step "+stepNumber);
			//stepNumber++;
		//}
		
		//System.out.println("proof has " + stepNumber + " steps");

		Runnable r = new Runnable() {
			public void run() {
				proofs.add(p);
				ProofViewer pv = new ProofViewer(p, autoUpdate, tryToDrawPictures);
				viewers.add(pv);
			}
		};
		if (SwingUtilities.isEventDispatchThread()) {
			new Thread(r).start();
		} else {
			r.run();
		}
	}

	public static void close(Proof p) {
		for (int i = 0; i < proofs.size(); i++) {
			Proof p2 = (Proof) proofs.get(i);
			if (p2 == p) {
				proofs.remove(p);
				viewers.remove(i);
				StaticObjects.mdf.stopWritingProof(p);
				return;
			}
		}
	}
}
