/*
 * Created on 22-Nov-2003
 *
 */
package rwd.rules.heuristics;



/**
 * @author jaf28
 * One component for a compound diagram heuristic
 */
public class CompoundContourMeasure {
    // PLEASE REMOVCE ME FROM CVS

/*    public static Vector getMeasure(Diagram d, boolean isMeasure1) {
        return getMeasure(d, isMeasure1, d);
    }
*/
/*    public static Vector getMeasure(
        Diagram d,
        boolean isMeasure1,
        Diagram context) {
        // find universal set of contours
        Vector leaves = d.getUnitaryParts();
        Vector allContours = new Vector();
        for (int i = 0; i < leaves.size(); i++) {
            UnitaryDiagram leaf = (UnitaryDiagram) leaves.get(i);
            if (!(leaf instanceof FalseDiagram)) {
                Vector contours = leaf.getContours();
                for (int j = 0; j < contours.size(); j++) {
                    Contour c = (Contour) contours.get(j);
                    if (!allContours.contains(c)) {
                        allContours.add(c);
                    }
                }
            }
        }
        leaves = context.getUnitaryParts();
        for (int i = 0; i < leaves.size(); i++) {
            UnitaryDiagram leaf = (UnitaryDiagram) leaves.get(i);
            if (!(leaf instanceof FalseDiagram)) {
                Vector contours = leaf.getContours();
                for (int j = 0; j < contours.size(); j++) {
                    Contour c = (Contour) contours.get(j);
                    if (!allContours.contains(c)) {
                        allContours.add(c);
                    }
                }
            }
        }
        return getMeasure(d, allContours, isMeasure1);
    }
*/
/*    public static Vector getMeasure(
        Diagram d,
        //Vector universalSet,
        boolean isMeasure1) {

        boolean isDebug = false;

        if (isMeasure1) {
            if (isDebug) {
                System.out.print("finding Contour1 ");
            }
        } else {
            if (isDebug) {
                System.out.print("finding Contour2 ");
            }
        }
        if (isDebug) {
            System.out.println("diagram is " + d);
        }

        if (d instanceof FalseDiagram) {
            throw new IllegalArgumentException();
            /*
            if (isMeasure1) {
                if (isDebug) {
                    System.out.println(
                        "measure for " + d + " is " + universalSet);
                }
                return universalSet;
            } else {
                if (isDebug) {
                    System.out.println("measure for " + d + " is emptyset");
                }
                return new Vector();
            }
        } else if (d instanceof UnitaryDiagram) {
            Vector contours = ((UnitaryDiagram) d).getContours();
            if (isDebug) {
                System.out.println("measure for " + d + " is " + contours);
            }
            return contours;
        } else if (d instanceof NotCompoundDiagram) {
            Vector contours =
                getMeasure(
                    (Diagram) (((NotCompoundDiagram) d).getChildren().get(0)),
                    //universalSet,
                    !isMeasure1);
            if (isDebug) {
                System.out.println("measure for " + d + " is " + contours);
            }
            return contours;

        } else if (d instanceof CompoundDiagram) {
            CompoundDiagram cd = (CompoundDiagram) d;
            Vector children = cd.getChildren();
            Vector measures = new Vector();
            for (int i = 0; i < children.size(); i++) {
                measures.add(
                    getMeasure(
                        (Diagram) (children.get(i)),
                        //universalSet,
                        isMeasure1));
            }
            if (!isMeasure1
                && d instanceof AndCompoundDiagram
                || (isMeasure1 && d instanceof OrCompoundDiagram)) {
                // take intersection for C2
                if (isDebug) {
                    System.out.println("now take intersection");
                }
                Vector result = new Vector();
                Vector firstChildSet = (Vector) measures.get(0);
                for (int i = 0; i < firstChildSet.size(); i++) {
                    Contour c = (Contour) firstChildSet.get(i);
                    boolean isEverywhere = true;
                    for (int j = 1; j < measures.size(); j++) {
                        if (!((Vector) (measures.get(j))).contains(c)) {
                            isEverywhere = false;
                        }
                    }
                    if (isEverywhere) {
                        result.add(c);
                    }

                }
                if (isDebug) {
                    System.out.println("measure for " + d + " is " + result);
                }
                return result;
            } else {
                // take union for C1
                if (isDebug) {
                    System.out.println("now take union");
                }
                Vector result = new Vector();
                for (int j = 0; j < measures.size(); j++) {
                    Vector set = (Vector) measures.get(j);
                    for (int i = 0; i < set.size(); i++) {
                        Contour c = (Contour) set.get(i);
                        if (!result.contains(c)) {
                            result.add(c);
                        }
                    }
                }
                if (isDebug) {
                    System.out.println("measure for " + d + " is " + result);
                }
                return result;
            }
        }
        throw new IllegalArgumentException();
    }

    private static Vector c1Before, c1After, c2Before, c2After;
    private static Diagram start, end;
    private static boolean c1Unchanged() {
        return c1HasntGrown() && c1HasntShrunk();
    }
    private static boolean c2Unchanged() {
        return c2HasntGrown() && c2HasntShrunk();
    }
    private static boolean c1HasntGrown() {
        return c1Before.containsAll(c1After);
    }
    private static boolean c2HasntGrown() {
        return c2Before.containsAll(c2After);
    }
    private static boolean c1HasntShrunk() {
        return c1After.containsAll(c1Before);
    }
    private static boolean c2HasntShrunk() {
        return c2After.containsAll(c2Before);
    }
    private static boolean c1HasntChangedByMoreThanOne() {
        return Math.abs(c1After.size() - c1Before.size()) <= 1;
    }
    private static boolean c2HasntChangedByMoreThanOne() {
        return Math.abs(c2After.size() - c2Before.size()) <= 1;
    }

    private static void showreport(String message) {
        System.out.println(message);
        System.out.println(
            "start diagram is " + DiagramFileUser.toSaveString(start));
        System.out.println(
            "result diagram is " + DiagramFileUser.toSaveString(end));
        System.out.println("c1Before " + c1Before);
        System.out.println("c1After " + c1After);
        System.out.println("c2Before " + c2Before);
        System.out.println("c2After " + c2After);
    }

    public static void main(String args[]) {
        // build suitable rule set
        HashMap resultsHM = new HashMap();
        Vector HRules = HeuristicProofWriter.compoundHRules;
        Rule[] rules = new Rule[HRules.size()];
        for (int i = 0; i < HRules.size(); i++) {
            rules[i] = (Rule) HRules.get(i);
            resultsHM.put(rules[i].name, new Integer(0));
        }

        // build one-step proofs        
        ProofGetterRandom pgr1 = new ProofGetterRandom(2, 3, 2, 1, rules);
        ProofGetterRandom pgr2 = new ProofGetterRandom(1, 1, 2, 6, rules);
        ProofGetterRandom pgr3 = new ProofGetterRandom(0, 3, 2, 2, rules);

        // see how the measures change
        for (int i = 0; i < 500000; i++) {
            if (i % 10000 == 0) {
                System.out.println("" + i);
            }
            Proof p = null;
            if (i % 3 == 0) {
                p = pgr1.getProof(1);
            } else if (i % 3 == 1) {
                p = pgr2.getProof(1);
            } else {
                p = pgr3.getProof(1);
            }
            if (p.numSteps() == 0) {
                i--;
            } else {
                start = p.getFirstDiagram();
                end = p.getLastDiagram();
                c1Before = getMeasure(start, true);//, end);
                c2Before = getMeasure(start, false);//, end);
                c1After = getMeasure(end, true);//, start);
                c2After = getMeasure(end, false);//, start);
                Rule r = p.getImminentRule();
                // log which rules we have experienced
                resultsHM.put(
                    r.name,
                    new Integer(
                        ((Integer) (resultsHM.get(r.name))).intValue() + 1));
                // by default we expect the measure to be left unchanged
                if (c1Unchanged() && c2Unchanged()) {
                } else if (r instanceof RuleAddContour) {
                    if (c1HasntShrunk()
                        && c1HasntChangedByMoreThanOne()
                        && c2HasntShrunk()
                        && c2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleDeleteContourSimple) {
                    if (c1HasntGrown()
                        && c1HasntChangedByMoreThanOne()
                        && c2HasntGrown()
                        && c1HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof MergeContradictionRule) {
                    if (c1HasntGrown() && c2HasntGrown()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof NotFalseIsTrueRule) {
                    if (c1HasntGrown() && c2HasntGrown()) {
                    } else {
                        showreport("" + r);
                    }
                } else {
                    showreport(" unexpected change : "+r);
                }
            }
        }
        System.out.println("");
        for (int i = 0; i < HRules.size(); i++) {
            Rule r = (Rule) HRules.get(i);
            System.out.println("" + resultsHM.get(r.name) + " " + r.name);
        }
    }
    */
}
