package rwd.rules.nospec;
import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.application.RuleApplicationSpec;

public class InsertNotNotRule extends RuleNoSpec {
	private InsertNotNotRule() {
		super("sd: P is Not(Not(P))");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new InsertNotNotRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
        return true;
	}
	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
		Diagram d = rajd.d;
        Vector justD = new Vector();
        justD.add(d);
        Diagram parent = new NotCompoundDiagram(justD,"not "+d.getName());
        Vector justParent = new Vector();
        justParent.add(parent);
        Diagram grandparent = new NotCompoundDiagram(justParent,"not "+parent.getName());
		return grandparent;
	}
}
