package rwd.abstractsyntax.spiderdiagram;
import java.util.Vector;
public class Utilities {
	public static Vector powerSet(Vector items) {
		Vector result = new Vector();
		result.add(new Vector());
		boolean[] flags = new boolean[items.size()];
		for (int i = 0; i < flags.length; i++) {
			flags[i] = false;
		}

		while (hasFalse(flags)) { // find first false flag and make it true
			// making trues to false as you go
			boolean hasSwitchedValue = false;
			int posnToSwitch = 0;
			while (!hasSwitchedValue) {
				if (flags[posnToSwitch]) {
					flags[posnToSwitch] = false;
				} else {
					flags[posnToSwitch] = true;
					hasSwitchedValue = true;
				}
				posnToSwitch++;
			}
			//System.out.println("flags:"+flags[0]+flags[1]);
			// make a String up now
			Vector subset = new Vector();
			for (int i = 0; i < flags.length; i++) {
				if (flags[i]) {
					subset.add(items.get(i));
				}
			}
			result.add(subset);
		}
		return result;
	}

	private static boolean hasFalse(boolean[] flags) {
		for (int i = 0; i < flags.length; i++) {
			if (flags[i] == false) {
				return true;
			}
		}
		return false;
	}

	public static void main(String args[]) {
		Vector abc = new Vector();
		abc.add("a");
		abc.add("b");
		abc.add("c");
		/**/
		System.out.println("" + powerSet(abc));
		/**/
		System.out.println(makeNameLike("hi"));
		/**/
		System.out.println(makeNameLike("hi0"));
		/**/
		System.out.println(makeNameLike("hi9"));
		/**/
		System.out.println(makeNameLike("hi10"));
	}

	public static String makeNameLike(String oldName) { // find out how much at the end represents a number
		if(oldName==null)
		{ oldName=""; }
		int endChars = 0;
		int n = 0;
		while (endChars < oldName.length()) {
			String endBit =
				oldName.substring(
					oldName.length() - endChars - 1,
					oldName.length());
			//System.out.println("endbit of "+oldName+" is "+endBit);
			try {
				n = Integer.parseInt(endBit);
				endChars++;
			} catch (NumberFormatException e) {
				return oldName.substring(0, oldName.length() - endChars)
					+ (n + 1);
			}
		}
		return oldName + "0";
	}
}
