package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFileChooser;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.dialogs.OptionsDialog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class ToolsOptionsListener implements ActionListener {
    public ToolsOptionsListener(EditorFrame frame) {
        this.frame = frame;    
    }

    public void actionPerformed(ActionEvent e) {
		// Create a dialog to input options
		OptionsDialog dialog = new OptionsDialog(frame, "Options");
		int returnVal = dialog.showOpenDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			EditorFrame.options = dialog.getOptions();
		}		
    }

    // Local variables
    protected EditorFrame frame;
}
