package rwd.gui.editor.writers;

import java.io.File;

import rwd.gui.editor.viewers.*;
import uk.ac.kent.cs.kmf.util.ILog;

/**
 * @author Octavian Patrascoiu
 *
 */
public abstract class DiagramWriter {
	public DiagramWriter(ILog log) {
		this.log = log;
	}
	public abstract void write(String fileName, DiagramViewerInterface viewer);
	public abstract void write(File file, DiagramViewerInterface viewer);
	
	//
	// Local properties
	//
	protected ILog log;
}
