package rwd.metrics;

import rwd.concretesyntax.ConcreteUnitaryDiagram;

/**
 * Compares two diagrams.
 */
public abstract class Comparison extends Metric {
	public Comparison(
		ConcreteUnitaryDiagram cud,
		double weighting,
		ConcreteUnitaryDiagram stillCud) {
		super(cud, weighting);
		this.stillCud = stillCud;
		name = "Comparison Metric";
		key = "CM";
	}

	public ConcreteUnitaryDiagram getStillCud() {
		return stillCud;
	}

	public void setStillCud(ConcreteUnitaryDiagram cud) {
		stillCud = cud;
	}

	//
	// Local properties
	//
	protected ConcreteUnitaryDiagram stillCud;
}
