package rwd.rules.nospec;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.application.RuleApplicationSpec;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import java.util.Vector;

public class AndIdempotentRule extends RuleNoSpec {
	private AndIdempotentRule() {
		super("sd: idempotency of AND");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new AndIdempotentRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
		return true;
	}
	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
		Diagram d = rajd.d;
		//System.out.println("applying rwd.rules to "+d);
		Vector diagrams = new Vector();
		diagrams.add(d);
		diagrams.add(d);
		Diagram dnew = new AndCompoundDiagram(diagrams, "outcome");
		//System.out.println("returning "+dnew);
		return dnew;
	}
}
