package rwd.tableaux.semantic;

import java.util.List;

import javax.swing.JTree;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.tableaux.syntax.ast.LogicalExp;

/**
 * @author Octavian Patrascoiu
 *
 */
public interface ETableau {
	// Build the JTree for a logical expressions 
	public boolean isDrawable();
	public JTree build(String strExp, Options opt, List diagrams);
	public JTree build(LogicalExp exp, Options opt, List diagrams);
	public JTree build(Diagram d, Options opt, List diagrams);
}
